public class And extends Gate {
  public And (float delay, Simulator s) {
    super(delay, nextId++, s);
  }
  public void connectInputA(Wire w){
    inA = w;
    w.connectTo(this);
  }
  public void connectInputB(Wire w){
    inB = w;
    w.connectTo(this);
  }
  public boolean computeOutput(){
    boolean a = inA.getValue();
    boolean b = inB.getValue();
    return(a && b);
  }
  
  private Wire inA, inB;
  private static int nextId = 0;
}