//import java.util.Scanner;
import java.util.*;

public class Source implements OutSignal, UpdateListener {
  
    private boolean output;
    private Simulator sim;
    private ArrayList<InSignal> drains;
    private ArrayList<String> data;
    private static int nextId=0;
    private final int id;
    private ArrayList<String> buff;
    	
    { 
    	id = nextId++;
    }
    public Source(ArrayList<String> in, Simulator s) {
	
	buff = new ArrayList<String>(1);
	String[] tempArr;
	String inTemp; 
	sim = s;
	data = in;
        //data.trimToSize();
    	//data.useLocale(Locale.US);
    	inTemp = data.get(0);
    	tempArr = inTemp.split("-");

    	float t = Float.parseFloat(tempArr[0]);
    	int vali = Integer.parseInt(tempArr[1]);
    	boolean val= vali==1;
    	buff.add(inTemp);
    	sim.add(new ChangeEvent(this, val, t));
        
    	drains = new ArrayList<InSignal>();
	data.remove(0);
  }
  
  public void updateOutputValue(boolean val) {
    
    String[] tempArr;
    String inTemp;
    if(val != output) 
        output = val;
    /*if (data.hasNextFloat()) {
       float time = data.nextFloat();
	   int nextVali = data.nextInt();
       boolean nextValue = nextVali==1;
	   	buff.append(time);
		buff.append('\t');
		buff.append(nextVali);
		buff.append('\n');
       sim.add(new ChangeEvent(this, nextValue, time));
    }*/
    System.out.println("\nActualizando valor de salida");
    System.out.println("data.size() = "+ Integer.toString(data.size())+ "\n");
    if (data.size()>0){  
 
	    inTemp = data.get(0);
	    buff.add(inTemp);
	    tempArr = inTemp.split("-");
	       
	    float time = Float.parseFloat(tempArr[0]);
	    int nextVali = Integer.parseInt(tempArr[1]);
	    boolean nextValue = nextVali==1;
	      
	    sim.add(new ChangeEvent(this, nextValue, time));
	    data.remove(0);
    }
    
  }
  public void propagateOutputValue() {
    for (InSignal drain: drains) 
      drain.inputValueChanged();
  }
  
  public boolean getValue() {
    return output;
  }
  public void connectOutput(InSignal drain) {
    if(drain!=null) {
      drains.add(drain);
      drain.addSource(this);
    }
  }
  public void connectDrain(InSignal drain) {
    if(drain!=null) drains.add(drain);
  }
  public void removeFromDrains(InSignal drain) {
    if(drain!=null) drains.remove(drain);
  }
  public void disconnectOutput(InSignal drain) {
    if(drain!=null){
      drains.remove(drain);
      drain.removeFromSource(this);
    }
  }
  public void disconnectAllOutput() {
    while (drains.size()!=0) {
       drains.get(0).removeFromSource(this);
       drains.remove(0);
    }
  }
  public String getDescription() {
    return getClass().getName()+"_"+id;
  }
  public void reset(){
    // Re
    String[] tempArr; 
    String inTemp; 
    output = true;
    data = buff;
    buff = new ArrayList<String>(1);
    // Set
    inTemp = data.get(0);
    buff.add(inTemp);
    tempArr = inTemp.split("-");

    float t = Float.parseFloat(tempArr[0]);
    int vali = Integer.parseInt(tempArr[1]);
    		
    boolean val= vali==1;
    sim.add(new ChangeEvent(this, val, t));
    data.remove(0);		
  }
}
